#ifndef _PANEL_H_
#define _PANEL_H_ 1

//#include "settings.h"
#include "settings.h"
#include <QtWidgets>
#include <qtabwidget.h>

class QComboBox;
class QBoxLayout;
class QSpinBox;
class QDoubleSpinBox;
class QTextEdit;

class Panel: public QTabWidget
{
    Q_OBJECT

public:
    Panel( QWidget * = NULL );

    Settings settings() const;
    void setSettings( const Settings & );
	void addWidgetWithLabel(QWidget *wd, QBoxLayout *layout, const char* name);

Q_SIGNALS:
    void settingsChanged( const Settings & );

private Q_SLOTS:
    void edited();

protected:
	//void timerEvent(QTimerEvent * e);

private:
    QWidget *createPlotTab( QWidget * );


	QComboBox *d_dataType;
	QDoubleSpinBox *d_timeRange;
	QDoubleSpinBox *d_valueRange_low;
	QDoubleSpinBox *d_valueRange_high;
	QSpinBox *d_samplingNum;
	QLineEdit *d_XAxis;
	QLineEdit *d_YAxis;
	QSpinBox *d_max_pointNum;
	QDoubleSpinBox *d_samplingTime;
	QCheckBox *d_realTime;



	QTextCodec* tc;
};

#endif
