#ifndef _PLOT_H_
#define _PLOT_H_ 1

#include <qwt_plot.h>
#include <qwt_system_clock.h>
#include "settings.h"

class QwtPlotGrid;
class QwtPlotCurve;

class Plot: public QwtPlot
{
    Q_OBJECT

public:
    Plot( QWidget* = NULL );

public Q_SLOTS:
    void setSettings( const Settings & );

protected:
    virtual void timerEvent( QTimerEvent *e );

private:
    void alignScales();
	void setPlotCurve(int num, std::string id);
    QwtPlotGrid *d_grid;
    std::vector<QwtPlotCurve*> d_curve;

    QwtSystemClock d_clock;
    double d_interval;

    int d_timerId;
	double valueRange_low;
	double valueRange_high;
	double timeRange;
	std::string XAxisLabel;
	std::string YAxisLabel;
};

#endif
