// -*-C++-*-
/*!
 * @file  WordObject.h
 * @brief Word̑
 */
#ifndef WordObject_H
#define WordObject_H

//using namespace Microsoft::Office::Interop::Word;
#define Word   Microsoft::Office::Interop::Word

#include <iostream>
#include <string>
#include <vector>
#include <windows.h>

#include "SubFunction.h"


/**
 * @class WordObject
*@brief Word𑀍삷NX
*/
ref class WordObject
{
public:
	/**
	*@brief RXgN^
	*/
	WordObject();

	static WordObject^ Obj; /**<@@brief  */

	
	/**
	*@brief Wordt@CJ֐
	* @param fn t@CpX
	*/
	void Open(System::String^ fn);
	
	/**
	*@brief COMIuWFNg֐
	*/
	void Close();

	
	/**
	*@brief ފ֐
	* @param st ޕ
	* @param m_code R[h
	*/
	void setWord(std::string st, std::string m_code);
	
	/**
	*@brief tHg̃TCYύX֐
	* @param fs tHgTCY
	*/
	void setFontSize(float fs);
	
	/**
	*@brief tHg̎ނύX֐
	* @param fn tHg̎
	*/
	void setFontName(std::string fn);

	
	/**
	*@brief IʒuύX֐
	* @param m_type ړ̃^Cv
	* @param leng ړ
	*/
	void moveSelection(Word::WdUnits m_type, int leng);

	
	/**
	*@brief Iʒu̕擾֐
	* @return 擾
	*/
	System::String^ getSelWord();

	
	/**
	*@brief ̐FύX֐
	* @param r ̐F(R)
	* @param g ̐F(G)
	* @param b ̐F(B)
	*/
	void setFontColor(int r, int g, int b);

	
	/**
	*@brief wiFύX֐
	* @param r ̐F(R)
	* @param g ̐F(G)
	* @param b ̐F(B)
	*/
	void setBackColor(int r, int g, int b);

	/**
	*@brief J[\ʒuXW擾(Pʂmm)
	* @return J[\ʒuXW
	*/
	float oCurrentCursorPositionX();
	/**
	*@brief J[\ʒuYW擾(Pʂmm)
	* @return J[\ʒuXW
	*/
	float oCurrentCursorPositionY();
	/**
	*@brief J[\hLg擪ֈړ
	*/
	void gotoStart();
	/**
	*@brief J[\hLgŌֈړ
	*/
	void gotoEnd();
	/**
	*@brief J[\s擪ֈړ
	*/
	void gotoStartOfLine();
	/**
	*@brief J[\sŌֈړ
	*/
	void gotoEndOfLine();


	System::String^ filename; /**<@@brief  */
	Word::Application^ dcApplication; /**<@@brief  */
	Word::Documents^ dcDocuments; /**<@@brief  */
	Word::Document^ dcDocument; /**<@@brief  */

	System::String^ fontName; /**<@@brief  */
	float fontSize; /**<@@brief  */

	int char_Red, char_Green, char_Blue; /**<@@brief  */

	bool movementType; /**<@@brief  */
	bool italic; /**<@@brief  */
	bool bold; /**<@@brief  */

	bool underline; /**<@@brief  */
	bool shadow; /**<@@brief  */
	bool strikeout; /**<@@brief  */
	bool contoured; /**<@@brief  */
	bool emphasis; /**<@@brief  */

	int back_Red, back_Green, back_Blue; /**<@@brief  */

	/**
	*@brief
	* @param pUtf8Str
	* @param nBytesOut
	* @return 
	*/
	static char* utf8_to_sjis(const char *pUtf8Str, int *nBytesOut);
	
	/**
	*@brief
	* @param pUcsStr
	* @param nBytesOut
	* @return 
	*/
	static char* utf16be_to_sjis(const wchar_t *pUcsStr, int *nBytesOut);

	/**
	*@brief
	* @param pUcs2
	* @param pUtf8
	* @param nUtf8Num
	* @param bCountOnly
	* @param bBigEndian
	* @return 
	*/
	static int utf8_to_utf16be_sub( wchar_t *pUcs2, const char *pUtf8, int nUtf8Num, BOOL bCountOnly, BOOL bBigEndian);

	/**
	*@brief
	* @param pUtf8Str
	* @param nNumOut
	* @param bBigEndian
	* @return 
	*/
	static wchar_t* utf8_to_utf16be(const char *pUtf8Str, int *nNumOut, BOOL bBigEndian);
	
};



#endif